VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form frmMain 
   Caption         =   "USB16VI  Version 1"
   ClientHeight    =   4545
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   3105
   LinkTopic       =   "Form1"
   ScaleHeight     =   4545
   ScaleWidth      =   3105
   StartUpPosition =   3  'Windows Default
   WhatsThisHelp   =   -1  'True
   Begin VB.Timer tmrPortSampleRate 
      Interval        =   10
      Left            =   720
      Top             =   3960
   End
   Begin VB.Frame frmDataPort 
      Caption         =   "Data Ports"
      Height          =   3375
      Left            =   120
      TabIndex        =   2
      Top             =   480
      Width           =   2895
      Begin VB.TextBox txtPortSampleRate 
         Alignment       =   2  'Center
         Enabled         =   0   'False
         Height          =   285
         Left            =   1920
         TabIndex        =   9
         Text            =   "1000"
         Top             =   600
         Width           =   495
      End
      Begin VB.TextBox txtPortSelected 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   360
         TabIndex        =   7
         Text            =   "B"
         Top             =   600
         Width           =   375
      End
      Begin VB.VScrollBar vsbPortSampleRate 
         Height          =   2295
         Left            =   2040
         Max             =   2000
         Min             =   10
         TabIndex        =   5
         Top             =   960
         Value           =   1000
         Width           =   255
      End
      Begin VB.TextBox txtPort1Value 
         Alignment       =   2  'Center
         BeginProperty DataFormat 
            Type            =   1
            Format          =   "Ox00"
            HaveTrueFalseNull=   0
            FirstDayOfWeek  =   0
            FirstWeekOfYear =   0
            LCID            =   2057
            SubFormatType   =   0
         EndProperty
         Height          =   285
         Left            =   240
         TabIndex        =   3
         Top             =   1800
         Width           =   735
      End
      Begin VB.Label lblPortSelect 
         Caption         =   "Port Selected"
         Height          =   255
         Left            =   120
         TabIndex        =   8
         Top             =   360
         Width           =   975
      End
      Begin VB.Label lblPortSampleRate 
         Alignment       =   2  'Center
         Caption         =   "Port sample rate (mSecs)"
         Height          =   375
         Left            =   1560
         TabIndex        =   6
         Top             =   120
         Width           =   1215
         WordWrap        =   -1  'True
      End
      Begin VB.Label lblPortValue 
         Alignment       =   2  'Center
         Caption         =   "PortValue (Hex)"
         Height          =   375
         Left            =   240
         TabIndex        =   4
         Top             =   1320
         Width           =   735
      End
   End
   Begin VB.TextBox txtComPort 
      Enabled         =   0   'False
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Text            =   "1"
      Top             =   120
      Width           =   255
   End
   Begin VB.Timer tmrCmdDelay 
      Interval        =   10
      Left            =   120
      Top             =   3960
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   1800
      Top             =   3960
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.Label Label5 
      Caption         =   "Comm Port"
      Height          =   255
      Left            =   600
      TabIndex        =   1
      Top             =   120
      Width           =   855
   End
   Begin VB.Menu mnuFile 
      Caption         =   "F&ile"
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuComm 
      Caption         =   "CommPort"
      Begin VB.Menu mnuPort1 
         Caption         =   "Port&1"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnuPort2 
         Caption         =   "Port&2"
      End
      Begin VB.Menu mnuPort3 
         Caption         =   "Port&3"
      End
      Begin VB.Menu mnuPort4 
         Caption         =   "Port&4"
      End
      Begin VB.Menu mnuPortSel 
         Caption         =   "Comm Port Select"
      End
   End
   Begin VB.Menu mnuDataPort 
      Caption         =   "Data&Port"
      Begin VB.Menu mnuPortB 
         Caption         =   "Port&B"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnuPortC 
         Caption         =   "Port&C"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'USB16VI Demonstrator
' Version 1.0
' Written by Philip Allen
' **************************************
Option Explicit

Dim gbPortNotReady As Boolean
Dim gUPortSelected As Byte

Private Sub CmdDelay(uVal As Integer)
    tmrCmdDelay.Interval = uVal
    
    tmrCmdDelay.Enabled = True
    gbPortNotReady = True
    
    While gbPortNotReady = True
        DoEvents
    Wend

End Sub

Private Function OpenCommPort(PortNum As Integer)
    Dim uRData(0) As Byte
    Dim Msg
    
On Error GoTo PortError

    If MSComm1.PortOpen = True Then
        MSComm1.PortOpen = False
    End If

    MSComm1.Settings = "9600,n,8,1"
    MSComm1.CommPort = PortNum
    MSComm1.PortOpen = True
    OpenCommPort = True
GoTo SubEnd

PortError:
    Msg = Err.Description
    MsgBox Msg, vbOKOnly
    
    ' Close port if open and set to default o 1
    If MSComm1.PortOpen = True Then
        MSComm1.PortOpen = False
    End If
    
    MSComm1.CommPort = 1
    OpenCommPort = False

SubEnd:

End Function
Private Sub SendCommand(cmd As String, Data() As Byte)
    If MSComm1.PortOpen = True Then
        MSComm1.Output = cmd
        MSComm1.Output = Data
        CmdDelay 20
    End If
End Sub
' This is fixed for USB16VI
Private Sub SetPortStates()
   Dim uPortData(0) As Byte
  
   uPortData(0) = &HFF
   'Port B
   SendCommand "B", uPortData  'B port all inputs
   
   uPortData(0) = &HFF
   'Port C
   SendCommand "E", uPortData  'C port
    
End Sub
Private Sub Initialise()

    Dim uRData(0) As Byte
    Dim i As Byte
       
    ' Set all PIC ports to Outputs
    SetPortStates
    ClearPorts
End Sub

Private Sub ReadPort(uPort As String)
    Dim uRData(0) As Byte
    Dim cPort As String
    Dim i As Integer
    Dim Length As Integer
    Dim MyString As String
    Dim PortValue As Integer
    
    i = 0
    Length = 0
    
    uRData(0) = 0
    If uPort = "B" Then
        cPort = "A"
        uRData(0) = 0
    Else
        If uPort = "C" Then
           cPort = "D"
           uRData(0) = &HF
        End If
    End If
    
    SendCommand cPort, uRData 'Read port
    
    Length = MSComm1.InBufferCount
    DoEvents
    
    If Length > 0 Then
       i = i
       MyString = MSComm1.Input
       PortValue = Asc(Mid(MyString, 1, 1))
    End If
    
    txtPort1Value.Text = "0x" + Hex(PortValue)
End Sub
    
Private Sub ClearPorts()
    Dim uRData(0) As Byte
    'Clear Port B
    uRData(0) = 0
    'First set to outputs
    SendCommand "B", uRData
    'Write all low
    SendCommand "C", uRData
    'set back to inputs
    uRData(0) = &HFF
    SendCommand "B", uRData
    
    'Clear Port C
    uRData(0) = &H0
    'First set to outputs
    SendCommand "E", uRData
    'Write all low
    SendCommand "F", uRData
    'set upper half back to inputs
    uRData(0) = &HF0
    SendCommand "E", uRData
    
End Sub


Private Sub EnableControls()
    Initialise
End Sub
Private Sub DisableControls()
End Sub


Private Sub Form_Load()
    Dim uComPortNum As Integer
    Dim sComPorStr As String
        
    DisableControls
           
    If MSComm1.PortOpen = True Then
        MSComm1.PortOpen = False
    End If
    
    vsbPortSampleRate.Value = 1000
    tmrPortSampleRate.Interval = vsbPortSampleRate.Value
    tmrPortSampleRate.Enabled = True
    
    sComPorStr = InputBox("Enter Comm Port Value", "USB16VI Ver:1", 1, , 200)
       
    If sComPorStr = "" Then
        uComPortNum = 1
    Else
        uComPortNum = Val(sComPorStr)
    End If
    
    If OpenCommPort(uComPortNum) Then
      EnableControls
        txtComPort.Text = uComPortNum
        Initialise
    End If
    
End Sub


Private Sub mnuExit_Click()
    'Check if port is open before trying to clear
    If MSComm1.PortOpen = True Then
        ClearPorts
    End If
    
    End
End Sub

Private Sub mnuPort1_Click()
    mnuPort1.Checked = True
    mnuPort2.Checked = False
    mnuPort3.Checked = False
    mnuPort4.Checked = False
    
    If OpenCommPort(1) = True Then
        txtComPort.Text = 1
        EnableControls
    Else
        txtComPort.Text = 0
        DisableControls
    End If
End Sub

Private Sub mnuPort2_Click()
    mnuPort1.Checked = False
    mnuPort2.Checked = True
    mnuPort3.Checked = False
    mnuPort4.Checked = False
    
    If OpenCommPort(2) = True Then
        txtComPort.Text = 2
        EnableControls
    Else
        txtComPort.Text = 0
        DisableControls
    End If
    
End Sub

Private Sub mnuPort3_Click()
    mnuPort1.Checked = False
    mnuPort2.Checked = False
    mnuPort3.Checked = True
    mnuPort4.Checked = False
        
    If OpenCommPort(3) = True Then
        txtComPort.Text = 3
        EnableControls
    Else
        txtComPort.Text = 0
        DisableControls
    End If
End Sub

Private Sub mnuPort4_Click()
    mnuPort1.Checked = False
    mnuPort2.Checked = False
    mnuPort3.Checked = False
    mnuPort4.Checked = True
    
    If OpenCommPort(4) = True Then
        txtComPort.Text = 4
        EnableControls
    Else
        txtComPort.Text = 0
        DisableControls
    End If
End Sub

Private Sub mnuPortB_Click()
    mnuPortB.Checked = True
    mnuPortC.Checked = False
    
    txtPortSelected.Text = "B"

End Sub

Private Sub mnuPortC_Click()
    mnuPortB.Checked = False
    mnuPortC.Checked = True
    
    txtPortSelected.Text = "C"

End Sub

Private Sub mnuPortSel_Click()
Dim PortNum As Integer
Dim sComPortStr As String

    mnuPort1.Checked = False
    mnuPort2.Checked = False
    mnuPort3.Checked = False
    mnuPort4.Checked = False
    
    sComPortStr = InputBox("Enter Comm Port Value", "USB16VI Demo", 1, , 200)
    
    If sComPortStr = "" Then
        PortNum = 0
    Else
        PortNum = Val(sComPortStr)
    End If
    
    If OpenCommPort(PortNum) = True Then
    
        txtComPort.Text = PortNum
        Select Case PortNum
        Case 1
             mnuPort1.Checked = True
        Case 2
             mnuPort2.Checked = True
        Case 3
             mnuPort3.Checked = True
        Case 4
             mnuPort4.Checked = True
        End Select
        EnableControls
    Else
        txtComPort.Text = 0
        DisableControls
    End If
End Sub

Private Sub MSComm1_OnComm()
Dim sPortValue As String

sPortValue = MSComm1.Input

End Sub

Private Sub tmrCmdDelay_Timer()
  gbPortNotReady = False
  tmrCmdDelay.Enabled = False
End Sub

Private Sub tmrPortSampleRate_Timer()
    ReadPort (txtPortSelected)
End Sub

Private Sub vsbPortSampleRate_Change()

vsbPortSampleRate.Value = Int(vsbPortSampleRate.Value / 10) * 10
txtPortSampleRate.Text = vsbPortSampleRate.Value
tmrPortSampleRate.Interval = vsbPortSampleRate.Value

End Sub


